/*
 * Copyright (c) 1999
 *      David Cross <crossd@cs.rpi.edu>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdlib.h>
#include "wcstring.h"

wchar_t *wcstok_r(wchar_t *wcs, const wchar_t *wcssep, wchar_t **wcslast)
{
  wchar_t *wcsbegin;
  size_t count;

  if (wcs)
    *wcslast=wcs;

  if (*wcslast == NULL || **wcslast == 0)
    return NULL;

  for (wcsbegin=*wcslast;*wcsbegin;wcsbegin++)
    for(count=0;wcssep[count] && (wcssep[count] != *wcsbegin);count++);

  *wcslast=wcsbegin;
  if (*wcsbegin == 0) 
    return NULL;

  for(;**wcslast;*(wcslast++) ){
    for(count=0;wcssep[count] && (wcssep[count] != **wcslast); count++);
    if (wcssep[count])
      break;
  }

  if (**wcslast)
   *((*wcslast)++)=0;
  return wcsbegin;
}

wchar_t *wcstok(wchar_t *wcs, const wchar_t *wcssep)
{
  static wchar_t *last=NULL;
  return wcstok_r(wcs, wcssep, &last);
}

wchar_t *wstok(wchar_t *wcs, const wchar_t *wcssep)
{
  static wchar_t *last=NULL;
  return wcstok_r(wcs, wcssep, &last);
}

wchar_t *wstok_r(wchar_t *wcs, const wchar_t *wcssep, wchar_t **last)
{
  return wcstok_r(wcs, wcssep, last);
}
